# FINOS Governance Policies

## Roles

The project community consists of Contributors and Maintainers:
* A **Contributor** is anyone who submits a contribution to the project
* A **Maintainer** is a Contributor who, by virtue of their contribution history, has been given write access to project repositories and may merge approved contributions

One maintainer will interface with FINOS on behalf of the team, and will approve [quarterly project reports](https://community.finos.org/docs/governance/#project-governing-board-reporting)

## Contribution Rules

Anyone is welcome to submit a contribution to the project. The rules below apply to all contributions:

* All contributions must be submitted as pull requests
* All pull requests should be reviewed by a maintainer before being merged
* Pull requests for non-trivial contributions should be discussed and reviewed amongst maintainers
* Approved pull requests can be merged by any maintainer
* In cases of disputes, maintainers can call for a vote

## Maintainer Voting

If consensus can't be reached on an issue, maintainers can call for a vote where majority rules. In the event of a tie, the most senior active maintainer (as defined by duration from first contribution) will be the tie breaker.

## Maintainer Qualifications

Maintainers can be added or removed via the voting process above. Prospective maintainers (or nominators) should open an issue on the project. No vote is required for an existing maintainer to relinquish their maintainer status.

## Changes to this Document

This document can be altered via pull request, subject to the above rules.
